Grantlee 5.3.0

Public Member Functions | List of all members
Grantlee::Template Class Reference

The Template class is a tree of nodes which may be rendered. More...

`#include <grantlee/template.h>`

Inheritance diagram for Grantlee::Template:
[legend]

## Public Member Functions
Engine const * | engine () const
Error | error () const
QString | errorString () const
QString | render (Context *c) const
OutputStream * | render (OutputStream *stream, Context *c) const

## Detailed Description

All Templates are created through the Grantlee::Engine class. A Template is created by parsing some text markup passed into the Engine, or by reading it from a file.

Note that Template is actually a typedef for a `QSharedPointer<TemplateImpl>`, so all of its members should be accessed with `operator->()`.

The result of parsing is a Template object which can be rendered multiple times with multiple different Contexts.

auto engine = getEngine();
auto t = engine->newTemplate(
"{{ name }} is aged {{ age }}",
"simple template" );
if ( t->error() )
{
// Tokenizing or parsing error, or couldn't find custom tags or filters.
qDebug() << t->errorString();
return;
}
QTextStream textStream( stdout );
OutputStream stream( textStream );
for ( ... )
{
Context c;
// ... c.insert
t->render( stream, c );
if (t->error())
{
// Rendering error.
qDebug() << t->errorString();
}
}
Grantlee::Context
The Context class holds the context to render a Template with.
Definition: context.h:118
Grantlee::Engine::newTemplate
Template newTemplate(const QString &content, const QString &name) const
Grantlee::OutputStream
The OutputStream class is used to render templates to a QTextStream.
Definition: outputstream.h:81
Grantlee::Template::engine
Engine const * engine() const
Grantlee::Template::errorString
QString errorString() const

If there is an error in parsing or rendering, the error and errorString methods can be used to check the source of the error.

Author
  Stephen Kelly steve.nosp@m.ire@.nosp@m.gmail.nosp@m..com

Definition at line 95 of file template.h.

## Member Function Documentation

## ◆ engine()

Engine const * Grantlee::Template::engine | ( |  | ) | const

Returns the Engine that created this Template.

## ◆ error()

Error Grantlee::Template::error | ( |  | ) | const

Returns an error code for the error encountered.

## ◆ errorString()

QString Grantlee::Template::errorString | ( |  | ) | const

Returns more information to developers in the form of a string.

## ◆ render() [1/2]

QString Grantlee::Template::render | ( | Context * | c | ) | const

Renders the Template to a string given the Context `c`.

## ◆ render() [2/2]

OutputStream * Grantlee::Template::render | ( | OutputStream * | stream,
|  | Context * | c
| ) |  | const

Renders the Template to the OutputStream `stream` given the Context c.